﻿// -----------------------------------------------------------------------
// <copyright file="FixedLength{T}.cs" company="none">
// Copyright (c) 2012 M. Alberti, xanatos(at)live.it
// Distributed under the MIT/X11 software license, see the accompanying
// file COPYING or http://www.opensource.org/licenses/mit-license.php.
// </copyright>
// -----------------------------------------------------------------------

namespace FluentSerializer.CollectionsHelpers
{
    using System.Linq.Expressions;

    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class FixedLength<T> : ICollectionHelper
    {
        #region IFluentSerializerCollectionHandler Members

        /// <summary>
        /// 
        /// </summary>
        public bool IsUniversal
        {
            get { return true; }
        }

        /// <summary>
        /// 
        /// </summary>
        public bool IsFixedLength
        {
            get { return true; }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="reader"></param>
        /// <param name="length"></param>
        /// <returns></returns>
        public Expression DeserializeLength(Expression reader, Expression length)
        {
            return null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="writer"></param>
        /// <param name="length"></param>
        /// <returns></returns>
        public Expression SerializeLength(Expression writer, Expression length)
        {
            return null;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="length"></param>
        /// <returns></returns>
        public Expression SizeLength(Expression length)
        {
            return null;
        }

        #endregion
    }
}