﻿// -----------------------------------------------------------------------
// <copyright file="ISerializer{T,TParameters}.cs" company="none">
// Copyright (c) 2012 M. Alberti, xanatos(at)live.it
// Distributed under the MIT/X11 software license, see the accompanying
// file COPYING or http://www.opensource.org/licenses/mit-license.php.
// </copyright>
// -----------------------------------------------------------------------

namespace FluentSerializer
{
    using System.Linq.Expressions;
    using FluentStatement;

    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="T"></typeparam>
    /// <typeparam name="TParameters"></typeparam>
    /// <param name="op"></param>
    /// <param name="obj"></param>
    /// <param name="par"></param>
    public delegate void Serializer<T, TParameters>(Operation op, T obj, TParameters par);

    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="T"></typeparam>
    /// <typeparam name="TParameters"></typeparam>
    public interface ISerializer<T, TParameters>
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        Expression<Serializer<T, TParameters>> GetSerializer();
    }
}